define(function(require) {
	var $ = require("jquery");
	var justep = require("$UI/system/lib/justep");
	var biz = require("$UI/system/lib/biz");

	var Model = function() {
		this.callParent();
		this.baiduMap = null;
		this.markerClusterer = null;
	};

	Model.prototype.loadBaiduMap = function() {
		var id = this.getIDByXID("baiduMap");
		var me = this;
		window._baiduInit = function() {
			var map = new BMap.Map(id, {
				enableMapClick : false
			// 去掉poi
			});
			me.baiduMap = map;
			map.centerAndZoom(new BMap.Point(116.39852,39.910286), 12);
			map.setCurrentCity("北京");
			map.addControl(new BMap.NavigationControl({
				anchor : BMAP_ANCHOR_TOP_RIGHT,
				type : BMAP_NAVIGATION_CONTROL_SMALL
			}));// 右上角，仅包含平移和缩放按钮
			map.enableScrollWheelZoom(true);// 可以滚轮缩放

			require([ "http://api.map.baidu.com/library/TextIconOverlay/1.2/src/TextIconOverlay_min.js", "http://api.map.baidu.com/library/MarkerClusterer/1.2/src/MarkerClusterer_min.js" ],
					function() {
						var markerClusterer = new BMapLib.MarkerClusterer(map);
						me.markerClusterer = markerClusterer;

						me._dataMain.refreshData();
						me.showInMap();
					});
		};
		require([ "http://api.map.baidu.com/api?v=2.0&ak=lqTFnMLzGrXlSQuZwYcv2HZ5TSlpQH2W&callback=_baiduInit" ], function() {
			if (window.BMap && window.BMap.Map) {
				window._baiduInit();
			}
		});
	};

	Model.prototype.modelLoad = function(event) {
		this.loadBaiduMap();
	};

	Model.prototype.showInMap = function() {
		var markers = [];
		this.markerClusterer.clearMarkers();
		this._dataMain.each(function(param) {
			var row = param.row;
			var pt = new BMap.Point(row.val("longitude"), row.val("latitude"));
			var marker = new BMap.Marker(pt);
			marker.addEventListener("click",
					function() {
						var info = row.val("ttime") + "  " + row.val("qdlb") + "<br/>" + "姓名" + ": " + row.val("username") + "<br/>" + "部门" + ": " + row.val("Department") + "<br/>" + "位置："
								+ row.val("dizhi");
						var infoWin = new BMap.InfoWindow(info);
						this.openInfoWindow(infoWin);
					});
			markers.push(marker);
		});
		this.markerClusterer.addMarkers(markers);
	};

	Model.prototype.modelModelConstruct = function(event) {
		this._dataMain = this.comp("dataMain");
	};

	return Model;
});